<?php 

//@UTF-8 kwst_referee.php
/*
 * KISA WEB Security Template(KWST) - PHP Version
 * 
 * Author : neodal <mirr1004@gmail.com>
 *
 * Last modified Oct 23 2007
 *
 */

if (!defined("__KWST_PHP_VERSION_BASE_DIR__"))
	return;

/* KWST 정책 파일 존재 검사 */
if (!file_exists(__KWST_PHP_VERSION_BASE_DIR__."/kwst_policy.php"))
	return;

/* KWST 정책 파일 참조 */
include_once(__KWST_PHP_VERSION_BASE_DIR__."/kwst_policy.php"); 


/* KWST 집행 프레임워크 함수들 */

/* KWST 리퍼리 경고 메시지 함수
 *
 * 함수명: kwst_referee_alert
 *
 * 정책 설정에 따라 입력된 메시지를 브라우져 화면에 출력하거나
 * 경고창을 통해 출력함. 스텔스 모드인 경우에는 아무것도 출력하지 않음
 *
 * 파라미터: 
 *    $msg - 출력할 메시지
 *
 * 리턴: 없음
 */
function kwst_referee_alert($msg)
{
	global $_KWST_POLICY, $_SERVER;

	/* 경고 부분 정책 존재 여부 */
	if (!isset($_KWST_POLICY['CONFIG']['ALERT']))
		return;

	/* 경고 정책 가져오기 */
	$policy['config'] =& $_KWST_POLICY['CONFIG']['ADMIN']['MODULE_NAME'];
	$policy['config_title'] = base64_decode($policy['config']);

	$policy['alert'] =& $_KWST_POLICY['CONFIG']['ALERT'];
	$policy['alert_alert'] = base64_decode($policy['alert']['ALERT']);
	$policy['alert_message'] = base64_decode($policy['alert']['MESSAGE']);
	$policy['alert_stealth'] = base64_decode($policy['alert']['STEALTH']);

		// 스텔스 모드일 경우
	if ($policy['alert_stealth'] == "TRUE") {
		Header("HTTP/1.1 403 Forbidden");
		Header("Connection: close");
		Header("Content-Type: text/html; charset=iso-8859-1");
		return;
	}

	$page = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'];

		// 메시지 모드일 경우
	if ($policy['alert_message'] == "TRUE") {
		echo "
			<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">
			<html>
			<head>
				<meta http-equiv\"=Content-Type\" content=\"text/html; charset=UTF-8\">
				<link rel=\"StyleSheet\" HREF=\"style.css\" type=\"text/css\" title=\"style\">
				<title>" . $policy['config_title'] . "</title>
			</head>
			<body bgcolor=\"#D0D0D0\">
				<center><br><br><br>
				<table width=\"300\" cellspacing=\"1\" cellpadding=\"20\" border=\"0\" bgcolor=\"#000000\">
					<tr>
					<td width=\"100%\" bgcolor=\"#FFFFFF\" style=\"line-height:160%\" nowrap align=\"center\">
					<b><font size=\"3\">※ KWST 웹보안템플릿 알림 ※</b><br><br>
					<b><font size=\"2\">KWST 보안템플릿에 의해 접근이 차단되었습니다.</b><br><br>
					<font color=\"#000000\"><b>--- 차단 페이지 ---</b><br><br>" . $page . "</b></font><br><br>
					<b>--- 차단 사유 ---</b><br><br><font color=\"red\">" . $msg . "</b></font><br><br>
					<font color=\"#404040\">특별한 사유 없이 위의 에러가 반복되면 관리자에게 문의하십시오.<br>
					위의 결과는 모두 별도의 로그에 기록됩니다.</font><br><br>
					</td>
					</tr>
				</table>
			</body>";

		return;
	}

		// 경고 모드일 경우
	if ($policy['alert_alert'] == "TRUE") {
		$alert_msg  = "<script> alert('";
		$alert_msg .= "\\n";
		$alert_msg .= "※ KWST 웹보안템플릿 알림 ※ \\n";
		$alert_msg .= "\\n";
		$alert_msg .= "KWST 보안템플릿에 의해 접근이 차단되었습니다.\\n";
		$alert_msg .= "\\n";
		$alert_msg .= "--- 차단 페이지 ---\\n\\n".$page."\\n";
		$alert_msg .= "\\n";
		$alert_msg .= "--- 차단 사유 ---\\n\\n".$msg."\\n";
		$alert_msg .= "\\n";
		$alert_msg .= "특별한 사유 없이 위의 에러가 반복되면 관리자에게 문의하십시오.\\n";
		$alert_msg .= "위의 결과는 모두 별도의 로그에 기록됩니다.\\n";
		$alert_msg .= "\\n";
		$alert_msg .= "'); history.back(-1);</script>";

		/* SITE 문자셋 설정에 따라 변환 */
		if (isset($_KWST_POLICY['CONFIG']['SITE']['CHARSET'])) {
			$policy['site_charset'] = $_KWST_POLICY['CONFIG']['SITE']['CHARSET'];
			$policy['site_charset']['eucKR'] = base64_decode($policy['site_charset']['eucKR']);

			if ($policy['site_charset']['eucKR'] == "TRUE") 
				$alert_msg = iconv("UTF-8", "eucKR", $alert_msg);
		}

		print($alert_msg);

		return;

	}

}


/* KWST 리퍼리 로깅 함수
 *
 * 함수명: kwst_referee_logger
 *
 * 정책 설정에 따라 입력된 로그 메시지를 로그 파일에 추가함
 * 무기록 모드인 경우에는 로그를 기록하지 않음
 *
 * 파라미터: 
 *    $msg - 로그 메시지
 *
 * 리턴: 없음
 */
function kwst_referee_logger($msg)
{
	global $_KWST_POLICY;

	/* 로그 부분 정책 존재 여부 */
	if (!isset($_KWST_POLICY['CONFIG']['LOG']))
		return;

	/* 로그 정책 가져오기 */
	$policy['log'] =& $_KWST_POLICY['CONFIG']['LOG'];
	$policy['log_bool'] = base64_decode($policy['log']['BOOL']);
	$policy['log_filename'] = base64_decode($policy['log']['FILENAME']);

	/* 로그 기록 여부 판단 */
	if ($policy['log_bool'] == "FALSE")
		return;

	/* 로그 남김 */
	$log['filename']  = __KWST_PHP_VERSION_BASE_DIR__;
	$log['filename'] .= "/log/" . date("Ymd") . "-" . $policy['log_filename'];

	if (!file_exists($log['filename']))
		$log['openmode'] = "w";
	else
		$log['openmode'] = "a+";

	$fd = fopen($log['filename'], $log['openmode']);
	if ($fd) {
		fwrite($fd, $msg, strlen($msg));
		fclose($fd);
	}

	return;
}


/* KWST 리퍼리 확장 정규표현식 체크 함수
 *
 * 함수명: kwst_referee_eregi
 *
 * 입력된 정규표현식 패턴과 입렶 문자열을 디코딩하고
 * UTF-8, CP949(eucKR)로 변환한 후 각각 테스트를 수행함
 *
 * 파라미터: 
 *    $regexp - 정규표현식 패턴
 *    $str - 입력된 문자열
 *
 * 리턴:
 *    ($utf8_regexp or $euckr_regexp) - 탐지된 정규표현식 패턴
 *    NULL - 탐지되지 않을 경우 널
 */
function kwst_referee_eregi($regexp, $str)
{
	global $_KWST_POLICY;
	
	$regexp = trim($regexp);
	$str = trim($str);

		// 예외사항
	if (!strlen($regexp) || !strlen($str))
		return NULL;

		// 입력값 디코딩
	$str = kwst_referee_urldecode($str);
	$str = kwst_referee_unhtmlentities($str);
	$str = kwst_referee_htmldecode($str);

		// slashes 덧붙임 제거
	if (get_magic_quotes_gpc())
		$str = stripslashes($str);

		/* SITE 문자셋 설정에 따라 변환 */
	$policy['site_charset']['UTF-8'] = "";
	$policy['site_charset']['eucKR'] = "";

	if (isset($_KWST_POLICY['CONFIG']['SITE']['CHARSET'])) 
		$policy['site_charset'] = $_KWST_POLICY['CONFIG']['SITE']['CHARSET'];

	$policy['site_charset']['UTF-8'] = base64_decode($policy['site_charset']['UTF-8']);
	$policy['site_charset']['eucKR'] = base64_decode($policy['site_charset']['eucKR']);

	// 정규표현식 체크
	if ($policy['site_charset']['eucKR'] == "TRUE") {
		$euckr_regexp = iconv("UTF-8", "eucKR", $regexp);
		if (eregi($euckr_regexp, $str)) 
			return $euckr_regexp;
	}

	if ($policy['site_charset']['UTF-8'] == "TRUE") {
		if (eregi($regexp, $str)) 
			return $regexp;
	}

	return NULL;
}

function kwst_referee_urldecode($str)
{
	/* HTTP URL Decoding */

		// ULl Decoding  ex., '+' -> ' '
	$str = urldecode($str);	

		// RAW ULl Decoding  ex., "%20"' -> ' '
	$str = rawurldecode($str);	

	return $str;
}

// For users prior to PHP 4.3.0 you may do this:
function kwst_referee_unhtmlentities($str)
{
	// replace numeric entities
	$str = preg_replace('~&#x([0-9a-f]+);~ei', 'chr(hexdec("\\1"))', $str);
	$str = preg_replace('~&#([0-9]+);~e', 'chr("\\1")', $str);

	$trans_tbl = get_html_translation_table(HTML_ENTITIES);
	$trans_tbl = array_flip($trans_tbl);

	return strtr($str, $trans_tbl);
}

function kwst_referee_htmldecode($str)
{
	/* ASCII Entities Decoding */

		// Hex encoding '&#x20;' -> ' '
	$str = preg_replace('~&#x([0-9a-f]+);~ei', 'chr(hexdec("\\1"))', $str);

		// Hex encoding without semicolons '&#x20' -> ' '
	$str = preg_replace('~&#x([0-9a-f]+)~ei', 'chr(hexdec("\\1"))', $str);

		// UTF-8 Unicode encoding '&#32;' -> ' '
	$str = preg_replace('~&#([0-9]+);~e', 'chr("\\1")', $str);

		// UTF-8 Unicode encoding without semicolons '&#32' -> ' '
	$str = preg_replace('~&#([0-9]+)~e', 'chr("\\1")', $str);

	return $str;
}

function kwst_referee_delete_directory_traverse($path)
{
	/* Delete directory traverse attack.. */

	$path = kwst_referee_urldecode($path);

		// "/../" -> "/"
	while (eregi("/\.\./", $path)) 
		$path = eregi_replace("/\.\./", "/", $path);

		// "./" -> ""
	while (eregi("\./", $path))
		$path = eregi_replace("\./", "", $path);

		// "//" -> "/"
	while (eregi("//", $path)) 
		$path = eregi_replace("//", "/", $path);

		// "\..\" -> "\"
	while (eregi("/\.\./", $path)) 
		$path = eregi_replace("\\\.\.\\", "\\", $path);

		// ".\" -> ""
	while (eregi("\./", $path))
		$path = eregi_replace("\.\\", "", $path);

		// "\\" -> "\"
	while (eregi("//", $path)) 
		$path = eregi_replace("\\\\", "\\", $path);

	return $path;
}

function kwst_referee_error_handler($policy_type, $rule, $method, $key, $value, $msg = "")
{
	global $_KWST_POLICY, $_SERVER;

	/* 경고 및 로그 부분 정책 존재 여부 */
	if (!isset($_KWST_POLICY['CONFIG']['ALERT']))
		return;

	if (!isset($_KWST_POLICY['CONFIG']['LOG']))
		return;

	/* 로그 정책 가져오기 */
	$policy['log'] =& $_KWST_POLICY['CONFIG']['LOG'];
	$policy['log_bool'] = base64_decode($policy['log']['BOOL']);
	$policy['log_simple'] = base64_decode($policy['log']['SIMPLE']);
	$policy['log_detail'] = base64_decode($policy['log']['DETAIL']);
	
	/* KWST 집행 모드 적용 */
	$policy['mode'] =& $_KWST_POLICY['CONFIG']['MODE'];
	$policy['mode_enforcing'] = base64_decode($policy['mode']['ENFORCING']);
	$policy['mode_permissive'] = base64_decode($policy['mode']['PERMISSIVE']);

	/* 로그 부분 정책 존재 여부 */
	if (!isset($_KWST_POLICY['POLICY']['SQL_INJECTION']))
		return;

	/* 로그 메시지 작성: REMOTE_ADDR - [DATE] REQUEST_URL : MESSAGE */

	/* LOG 문자셋 설정에 따라 변환 */
	$policy['log_charset']['eucKR'] = "";
	if (isset($_KWST_POLICY['CONFIG']['LOG']['CHARSET'])) {
		$policy['log_charset'] = $_KWST_POLICY['CONFIG']['LOG']['CHARSET'];
		$policy['log_charset']['eucKR'] = base64_decode($policy['log_charset']['eucKR']);
	}

		// 개행제거
	$value = eregi_replace("\r", "\\r", $value);
	$value = eregi_replace("\n", "\\n", $value);

		// 간략 메시지 작성
	if ($policy['log_simple'] == "TRUE") {
		$log['simple']  = $_SERVER['REMOTE_ADDR'] . " - [" . date("d/M/Y:H:i:s O") . "] ";
		$log['simple'] .= $_SERVER['PHP_SELF'] . ": " . $key . " = " . substr($value, 0, 64) . ": ";

		if ($policy['log_charset']['eucKR'] == "TRUE")
			$log['simple'] .= iconv("UTF-8", "eucKR", $msg) . "\n";
		else
			$log['simple'] .= $msg . "\n";

		kwst_referee_logger($log['simple']);
	}
	else
		// 상세 메시지 작성
	if ($policy['log_detail'] == "TRUE") {
		$log['detail']  = $_SERVER['REMOTE_ADDR'] . " - [" . date("d/M/Y:H:i:s O") . "] ";
		$log['detail'] .= $_SERVER['PHP_SELF'] . ": " . $key . " = " . substr($value, 0, 64) . ": ";

		if ($policy['log_charset']['eucKR'] == "TRUE")
			$log['detail'] .= iconv("UTF-8", "eucKR", $msg) . "\n";
		else
			$log['detail'] .= $msg . "\n";

		$log['detail'] .= " -> [Method: " . $method . "]\n";

		if ($policy['log_charset']['eucKR'] == "TRUE")
			$log['detail'] .= " -> [Policy: " . iconv("UTF-8", "eucKR", $policy_type) . "]\n"; 
		else
			$log['detail'] .= " -> [Policy: " . $policy_type . "]\n"; 

		$log['detail'] .= " -> [Pattern: " . $rule . "]\n";

		$rule = "/".$rule."/";

		@preg_match_all($rule, $value, $matches);

			// 상세 정보 출력
		if (isset($matches) && $matches) {
			foreach ($matches as $matched) 
			{
				$offset_sum = $offset = 0;
				foreach ($matched as $matched_value) {
					$offset = strpos($value, $matched_value, $offset_sum);
					$offset_sum += $offset + strlen($matched_value);
					if ($offset)
						$log['detail'] .= " -> [Offset: ". $offset . "] [Matched-Content: " . $matched_value . "]\n";
				}
			}
		}

		kwst_referee_logger($log['detail']);
	}


		// 집행모드이면 강제 종료
	if ($policy['mode_enforcing'] == "TRUE") {
		kwst_referee_alert($msg.": ".$key);
		exit;
	}

		// 감사모드이면 계속 실행
	if ($policy['mode_permissive'] == "TRUE")
		return;

	return;
}

function kwst_referee_detect_sql_injection($string)
{
	global $_KWST_POLICY;

	/* SQL INJECTION 정책 존재 여부 */
	if (!isset($_KWST_POLICY['POLICY']['SQL_INJECTION']))
		return;

	$policy['sql_injection'] =& $_KWST_POLICY['POLICY']['SQL_INJECTION'];

	$policy['sql_injection_bool'] = $policy['sql_injection']['BOOL'];
	$policy['sql_injection_bool'] = base64_decode($policy['sql_injection_bool']);

		// SQL INJECTION 미적용 모드
	if ($policy['sql_injection_bool'] == "FALSE")
		return;

	$policy['sql_injection_list'] = $policy['sql_injection']['LIST'];

		// 정규표현식으로 탐지
	foreach ($policy['sql_injection_list'] as $regexp)
	{
		$regexp = base64_decode($regexp);
		$regexp = kwst_referee_eregi($regexp, $string);
		if ($regexp)
			return $regexp;
	}

	return FALSE;
}

function kwst_referee_detect_xss($string)
{
	global $_KWST_POLICY;

	/* XSS 정책 존재 여부 */
	if (!isset($_KWST_POLICY['POLICY']['XSS']))
		return;

	$policy['xss'] =& $_KWST_POLICY['POLICY']['XSS'];

	$policy['xss_bool'] = $policy['xss']['BOOL'];
	$policy['xss_bool'] = base64_decode($policy['xss_bool']);

		// XSS 미적용 모드
	if ($policy['xss_bool'] == "FALSE")
		return;

	$policy['xss_list'] = $policy['xss']['LIST'];

		// 정규표현식으로 탐지
	foreach ($policy['xss_list'] as $regexp)
	{
		$regexp = base64_decode($regexp);
		$regexp = kwst_referee_eregi($regexp, $string);
		if ($regexp)
			return $regexp;
	}

	return FALSE;
}

function kwst_referee_detect_word($string)
{
	global $_KWST_POLICY;

	/* WORD 정책 존재 여부 */
	if (!isset($_KWST_POLICY['POLICY']['WORD']))
		return;

	$policy['word'] =& $_KWST_POLICY['POLICY']['WORD'];

	$policy['word_bool'] = $policy['word']['BOOL'];
	$policy['word_bool'] = base64_decode($policy['word_bool']);

		// WORD 미적용 모드
	if ($policy['word_bool'] == "FALSE")
		return;

	$policy['word_list'] = $policy['word']['LIST'];

		// 정규표현식으로 탐지
	foreach ($policy['word_list'] as $regexp)
	{
		$regexp = base64_decode($regexp);
		$regexp = kwst_referee_eregi($regexp, $string);
		if ($regexp)
			return $regexp;
	}

	return FALSE;
}

function kwst_referee_detect_tag($string)
{
	global $_KWST_POLICY;

	/* TAG 정책 존재 여부 */
	if (!isset($_KWST_POLICY['POLICY']['TAG']))
		return;

	$policy['tag'] =& $_KWST_POLICY['POLICY']['TAG'];

	$policy['tag_bool'] = $policy['tag']['BOOL'];
	$policy['tag_bool'] = base64_decode($policy['tag_bool']);

		// TAG 미적용 모드
	if ($policy['tag_bool'] == "FALSE")
		return;

	$policy['tag_list'] = $policy['tag']['LIST'];

		// 정규표현식으로 탐지
	foreach ($policy['tag_list'] as $regexp)
	{
		$regexp = base64_decode($regexp);
		$regexp = kwst_referee_eregi($regexp, $string);
		if ($regexp)
			return $regexp;
	}

	return FALSE;
}

function kwst_referee_check_ip_policy()
{
	global $_KWST_POLICY;

		// 클라이언트 아이피 가져옴
	$check['ip'] = getenv("REMOTE_ADDR");

	if (isset($_KWST_POLICY['POLICY']['IP']))
		$policy['ip'] =& $_KWST_POLICY['POLICY']['IP'];

	/* 아이피 정책 존배 판단 : IP 정책이 없으면 기본 허용 */
	if (!isset($policy['ip'])) 
		return;

	$policy['ip_bool'] = base64_decode($policy['ip']['BOOL']);
	$policy['ip_allow'] = base64_decode($policy['ip']['ALLOW']);
	$policy['ip_deny'] = base64_decode($policy['ip']['DENY']);
	
		// 아이피 검사 사용 안함 
	if ($policy['ip_bool'] == "FALSE") 
		return;

		// 목록 존재 판단
	if (!isset($policy['ip']['LIST']))
		return;

		// 목록 가져오기 
	$policy['ip_list'] = $policy['ip']['LIST'];

		// 목록에서 아이피 존재 검사
	$ip_exists = FALSE;
	foreach ($policy['ip_list'] as $ip_regexp) 
	{
		$ip_regexp = base64_decode($ip_regexp);
			// 아이피의 경우 . -> \.로 변경
		if (kwst_referee_eregi($ip_regexp, $check['ip'])) 
			$ip_exists = TRUE;
	}
	
	/* 아이피 허용기반 정책 적용 */
		// 화이트리스트
	if ($policy['ip_allow'] == "TRUE") {
		if (!$ip_exists)
			kwst_referee_error_handler("아이피정책", "check remote_ip", 
									  "IP", stripslashes($check['ip']), "",
									  "허용되지 않은 아이피 대역에서 접근 시도");
	}
	else 
		// 블랙리스트
	if ($policy['ip_deny'] == "TRUE") {
		if ($ip_exists)
			kwst_referee_error_handler("아이피정책", "check remote_ip", 
									  "IP", stripslashes($check['ip']), "",
									  "차단된 아이피 대역에서 접근 시도");
	}

	return;
}

function kwst_referee_check_file_policy()
{
	global $_KWST_POLICY, $_FILE;

		// 파일 변수가 없음 
	if (!isset($_FILES))
		return;

		// 파일 관련 정책 가져옴
	$policy['filename'] = "";
	if (isset($_KWST_POLICY['POLICY']['FILENAME'])) 
		$policy['filename'] =& $_KWST_POLICY['POLICY']['FILENAME'];

	$policy['filetype'] = "";
	if (isset($_KWST_POLICY['POLICY']['FILETYPE'])) 
		$policy['filetype'] =& $_KWST_POLICY['POLICY']['FILETYPE'];

	$policy['filesize'] = "";
	if (isset($_KWST_POLICY['POLICY']['FILESIZE'])) 
		$policy['filesize'] =& $_KWST_POLICY['POLICY']['FILESIZE'];

	/* 파일 이름 정책 적용 */
	$policy['filename_bool'] = base64_decode($policy['filename']['BOOL']);
	$policy['filename_allow'] = base64_decode($policy['filename']['ALLOW']);
	$policy['filename_deny'] = base64_decode($policy['filename']['DENY']);

	/* 파일 타입 정책 적용 */
	$policy['filetype_bool'] = base64_decode($policy['filetype']['BOOL']);
	$policy['filetype_allow'] = base64_decode($policy['filetype']['ALLOW']);
	$policy['filetype_deny'] = base64_decode($policy['filetype']['DENY']);

	/* 파일 크기 정책 적용 */
	$policy['filesize_bool'] = base64_decode($policy['filesize']['BOOL']);
	$policy['filesize_min_size'] = base64_decode($policy['filesize']['MIN_SIZE']);
	$policy['filesize_max_size'] = base64_decode($policy['filesize']['MAX_SIZE']);

	foreach ($_FILES as $var => $fileinfo) 
	{
		$check['filename'] = $fileinfo['name'];
		$check['filevar'] = $var;
		$check['filetype'] = array_pop(explode('.', $fileinfo['name']));
		$check['filesize'] = $fileinfo['size'];

			// 파일 업로드 체크
		if ($fileinfo['error'])
			return;

			// 파일 이름 정책 적용 모드
		if ($policy['filename_bool'] == "TRUE")  {

			if (isset($policy['filename']['LIST'])) {
				$policy['filename_list'] = $policy['filename']['LIST'];

				$filename_exists = FALSE;
				foreach ($policy['filename_list'] as $filename) 
				{
					$filename_regexp = base64_decode($filename);
					if (kwst_referee_eregi($filename_regexp, $check['filename']))
						$filename_exists = TRUE;
				}
			}

			/* 파일이름 허용기반 정책 적용 */
				// 화이트리스트
			if ($policy['filename_allow'] == "TRUE") {
				if (!$filename_exists)
					kwst_referee_error_handler("파일정책", "check filename", 
											  "FILE", $check['filevar'], $check['filename'],
											  "허용되지 않은 이름 파일 업로드");
			}
			else 
				// 블랙리스트
			if ($policy['filename_deny'] == "TRUE") {
				if ($filename_exists)
					kwst_referee_error_handler("파일정책", "check filename", 
											  "FILE", $check['filevar'], $check['filename'],
											  "차단된 이름 파일 업로드");
			}

		}

			// 파일 확장자 정책 적용 모드
		if ($policy['filetype_bool'] == "TRUE")  {

			if (isset($policy['filetype']['LIST'])) {
				$policy['filetype_list'] = $policy['filetype']['LIST'];

				$filetype_exists = FALSE;
				foreach ($policy['filetype_list'] as $filetype) 
				{
					$filetype_regexp = base64_decode($filetype);
					if (kwst_referee_eregi($filetype_regexp, $check['filetype']))
						$filetype_exists = TRUE;
				}
			}

			/* 파일 확장자 허용기반 정책 적용 */
				// 화이트리스트
			if ($policy['filetype_allow'] == "TRUE") {
				if (!$filetype_exists)
					kwst_referee_error_handler("파일정책", "check filetype", 
											  "FILE", $check['filevar'], $check['filename'],
											  "허용되지 않은 확장자 파일 업로드");
			}
			else 
				// 블랙리스트
			if ($policy['filetype_deny'] == "TRUE") {
				if ($filetype_exists)
					kwst_referee_error_handler("파일정책", "check filetype", 
											  "FILE", $check['filevar'], $check['filename'],
											  "차단된 확장자 파일 업로드");
			}

		}

			// 파일 크기 정책 적용 모드
		if ($policy['filesize_bool'] == "TRUE")  {

				// 최소 크기 검사
			if ($check['filesize'] < $policy['filesize_min_size'])
				kwst_referee_error_handler("파일정책", ">=".$policy['filesize_min_size'], 
										  "FILE", $check['filevar'], $check['filesize'], 
										  "최소 크기보다 작은 파일 업로드");

				// 최대 크기 검사
			if ($check['filesize'] > $policy['filesize_max_size'])
				kwst_referee_error_handler("파일정책", "<=".$policy['filesize_max_size'],
										  "FILE", $check['filevar'], $check['filesize'], 
										  "최대 크기보다 큰 파일 업로드");

		}

	}

	return;
}

function kwst_referee_check_site_policy()
{
	global $_KWST_POLICY, $_SERVER;

	/* 사이트 정책 적용 */
	if (!isset($_KWST_POLICY['CONFIG']['SITE']['BOOL'])) 
		return;

		// 사이트 정책 가져오기
	$policy['site'] =& $_KWST_POLICY['CONFIG']['SITE']['BOOL'];
	$policy['site'] = base64_decode($policy['site']);

		// 사이트 정책 적용
	if ($policy['site'] == "FALSE")
		kwst_referee_error_handler("사이트정책", "check site-policy", "SITE", "차단됨", "", "사이트 폐쇄");

	return;
}

function kwst_referee_check_basic_policy()
{
	global $_KWST_POLICY, $_SERVER;

		// 페이지 이름을 가져옴
	$check['page_name'] = getenv("SCRIPT_NAME");
	$check['page_name'] = kwst_referee_delete_directory_traverse($check['page_name']);

	if (isset($_KWST_POLICY['ADVANCE']['PAGE'][$check['page_name']])) 
		$policy['page'] =& $_KWST_POLICY['ADVANCE']['PAGE'][$check['page_name']];

	/* 등록된 페이지 정책 적용 */
	if (isset($policy['page'])) 
		return;

	/* GET 메소드 처리 */
	foreach ($_GET as $key => $value) 
	{
		/* 탐지 대상별 탐지 */

			// SQL_INJECTION 탐지
		$pattern = kwst_referee_detect_sql_injection($value);
		if ($pattern)
			kwst_referee_error_handler("기본정책", $pattern, "GET", $key, $value, "SQL_Injection 공격 패턴 탐지");

			// XSS 탐지
		$pattern = kwst_referee_detect_xss($value);
		if ($pattern)
			kwst_referee_error_handler("기본정책", $pattern, "GET", $key, $value, "XSS 공격 패턴 탐지");
		
			// WORD 탐지

		$pattern = kwst_referee_detect_word($value);
		if ($pattern)
			kwst_referee_error_handler("기본정책", $pattern, "GET", $key, $value, "불량 WORD 탐지");
		
			// TAG 탐지
		$pattern = kwst_referee_detect_tag($value);
		if ($pattern)
			kwst_referee_error_handler("기본정책", $pattern, "GET", $key, $value, "TAG 공격 패턴 탐지");
	}

	/* POST 메소드 처리 */
	foreach ($_POST as $key => $value) 
	{
		/* 탐지 대상별 탐지 */
			// SQL_INJECTION 탐지
		$pattern = kwst_referee_detect_sql_injection($value);
		if ($pattern)
			kwst_referee_error_handler("기본정책", $pattern, "POST", $key, $value, "SQL_Injection 공격 패턴 탐지");

			// XSS 탐지
		$pattern = kwst_referee_detect_xss($value);
		if ($pattern)
			kwst_referee_error_handler("기본정책", $pattern, "POST", $key, $value, "XSS 공격 패턴 탐지");

			// WORD 탐지
		$pattern = kwst_referee_detect_word($value);
		if ($pattern)
			kwst_referee_error_handler("기본정책", $pattern, "POST", $key, $value, "불량 WORD 탐지");

			// TAG 탐지
		$pattern = kwst_referee_detect_tag($value);
		if ($pattern)
			kwst_referee_error_handler("기본정책", $pattern, "POST", $key, $value, "TAG 공격 패턴 탐지");
	}

	return;
}

function kwst_referee_check_cookie_policy()
{
	/* COOKIE 전역 변수 처리 */
	foreach ($_COOKIE as $key => $value) 
	{
		/* 탐지 대상별 탐지 */

			// SQL_INJECTION 탐지
		$pattern = kwst_referee_detect_sql_injection($value);
		if ($pattern)
			kwst_referee_error_handler("기본정책", $pattern, "COOKIE", $key, $value, "SQL_Injection 공격 패턴 탐지");

			// XSS 탐지
		$pattern = kwst_referee_detect_xss($value);
		if ($pattern)
			kwst_referee_error_handler("기본정책", $pattern, "COOKIE", $key, $value, "XSS 공격 패턴 탐지");
		
			// WORD 탐지
		$pattern = kwst_referee_detect_word($value);
		if ($pattern)
			kwst_referee_error_handler("기본정책", $pattern, "COOKIE", $key, $value, "불량 WORD 탐지");
		
			// TAG 탐지
		$pattern = kwst_referee_detect_tag($value);
		if ($pattern)
			kwst_referee_error_handler("기본정책", $pattern, "COOKIE", $key, $value, "TAG 공격 패턴 탐지");
	}

	return;
}

function kwst_referee_check_advance_policy()
{
	global $_KWST_POLICY;

		// 페이지 이름을 가져옴
	$check['page_name'] = getenv("SCRIPT_NAME");
	$check['page_name'] = kwst_referee_delete_directory_traverse($check['page_name']);

	if (isset($_KWST_POLICY['ADVANCE']['PAGE'][$check['page_name']])) 
		$policy['page'] =& $_KWST_POLICY['ADVANCE']['PAGE'][$check['page_name']];

	/* 등록된 페이지 정책 적용 */
	if (!isset($policy['page'])) 
		return;

	/* 페이지 허용/차단 정책 적용 */
	$policy['page_bool'] = base64_decode($policy['page']['BOOL']);
	$policy['page_allow'] = base64_decode($policy['page']['ALLOW']);
	$policy['page_deny'] = base64_decode($policy['page']['DENY']);

		// FALSE인 경우 차단
	if ($policy['page_bool'] == "FALSE")
		kwst_referee_error_handler("고급정책", "check page", "PAGE", $check['page_name'], "", "차단된 페이지 접근 시도");

	/* GET 메소드 처리 */
	foreach ($_GET as $key => $value) 
	{
		/* 페이지 허용기반 정책 적용 */

			// 화이트리스트
		if ($policy['page_allow'] == "TRUE") {
			if (!isset($policy['page']['LIST'][$key])) 
				kwst_referee_error_handler("고급정책", "check white-list", "GET", $key, "", "허용되지 않은 변수 접근 시도");
		}
		else 
			// 블랙리스트
		if ($policy['page_deny'] == "TRUE") {
			if (isset($policy['page']['LIST'][$key])) 
				kwst_referee_error_handler("고급정책", "check black-list", "GET", $key, "", "차단된 변수 접근 시도");
		}

			// 변수 가져오기
		if (!isset($policy['page']['LIST'][$key])) 
			continue;

		$policy['var'] = $policy['page']['LIST'][$key];

			// GET 메소드 사용 유무 탐지
		$policy['get_bool'] = base64_decode($policy['var']['METHOD']['GET']);
		if ($policy['get_bool'] == "FALSE")
			kwst_referee_error_handler("고급정책", "check method", "GET", $key, "", "차단된 메소드 접근 시도");

		/* 변수 데이터 형태별 정책 적용 */
		$policy['format'] = "";
		if (isset($policy['var']['FORMAT']))
			$policy['format'] = $policy['var']['FORMAT'];

		$policy['format'] = trim($policy['format']);
 
		if (strlen($policy['format']) > 0) {
			$policy['format'] = base64_decode($policy['format']);	

			if (!kwst_referee_eregi($policy['format'], $value))
				kwst_referee_error_handler("고급정책", $policy['format'], "GET", $key, $value, "지정되지 않은 형태의 변수값 입력");
		}

		/* 변수 데이터 길이 정책 적용 */
		$submit[$key]['length'] = strlen($value);

			// 최소길이 검사
		if (isset($policy['var']['MIN_LENGTH'])) {
			$policy['min_length'] = base64_decode($policy['var']['MIN_LENGTH']);

			if ($submit[$key]['length'] < $policy['min_length'])
				kwst_referee_error_handler("고급정책", ">=".$policy['min_length'], "GET", $key, $value, "최소 길이보다 작은 변수값 입력");
		}
			// 최대길이 검사
		if (isset($policy['var']['MAX_LENGTH'])) {
			$policy['max_length'] = base64_decode($policy['var']['MAX_LENGTH']);

			if ($submit[$key]['length'] > $policy['max_length'])
				kwst_referee_error_handler("고급정책", "<=".$policy['max_length'], "GET", $key, $value, "최대 길이보다 큰 변수값 입력");
		}

		/* 탐지 대상별 탐지 */

			// SQL_INJECTION 탐지
		$policy['sql_injection_bool'] = "FALSE";
		if (isset($policy['var']['TARGET']['SQL_INJECTION']))
			$policy['sql_injection_bool'] = base64_decode($policy['var']['TARGET']['SQL_INJECTION']);

		if ($policy['sql_injection_bool'] == "TRUE") {
			$pattern = kwst_referee_detect_sql_injection($value);
			if ($pattern)
				kwst_referee_error_handler("고급정책", $pattern, "GET", $key, $value, "SQL_Injection 공격 패턴 탐지");
		}

			// XSS 탐지
		$policy['xss'] = "FALSE";
		if (isset($policy['var']['TARGET']['XSS']))
			$policy['xss'] = base64_decode($policy['var']['TARGET']['XSS']);

		if ($policy['xss'] == "TRUE") {
			kwst_referee_detect_xss($value);
			if ($pattern)
				kwst_referee_error_handler("고급정책", $pattern, "GET", $key, $value, "XSS 공격 패턴 탐지");
		}

			// WORD 탐지
		$policy['word'] = "FALSE";
		if (isset($policy['var']['TARGET']['WORD']))
			$policy['word'] = base64_decode($policy['var']['TARGET']['WORD']);

		if ($policy['word'] == "TRUE") {
			$pattern = kwst_referee_detect_word($value);
			if ($pattern)
				kwst_referee_error_handler("고급정책", $pattern, "GET", $key, $value, "불량 WORD 탐지");
		}

			// TAG 탐지
		$policy['tag'] = "FALSE";
		if (isset($policy['var']['TARGET']['TAG']))
			$policy['tag'] = base64_decode($policy['var']['TARGET']['TAG']);

		if ($policy['tag'] == "TRUE") {
			$pattern = kwst_referee_detect_tag($value);
			if ($pattern)
				kwst_referee_error_handler("고급정책", $pattern, "GET", $key, $value, "TAG 공격 패턴 탐지");
		}

	}


	/* POST 메소드 처리 */
	foreach ($_POST as $key => $value) 
	{

		/* 페이지 허용기반 정책 적용 */
			// 화이트리스트
		if ($policy['page_allow'] == "TRUE") {
			if (!isset($policy['page']['LIST'][$key])) 
				kwst_referee_error_handler("고급정책", "check white-list", "POST", $key, "", "허용되지 않은 변수 접근 시도");
		}
		else 
			// 블랙리스트
		if ($policy['page_deny'] == "TRUE") {
			if (isset($policy['page']['LIST'][$key])) 
				kwst_referee_error_handler("고급정책", "check black-list", "POST", $key, "", "차단된 변수 접근 시도");
		}

			// 변수 가져오기
		if (!isset($policy['page']['LIST'][$key]))
			continue;

		$policy['var'] = $policy['page']['LIST'][$key];

		/* 변수 데이터 길이 정책 적용 */

			// POST 메소드 사용 유무 탐지
		$policy['post_bool'] = base64_decode($policy['var']['METHOD']['POST']);
		if ($policy['post_bool'] == "FALSE")
			kwst_referee_error_handler("고급정책", "check method", "POST", $key, "", "차단된 메소드 접근 시도");

		/* 변수 데이터 형태별 정책 적용 */
		$policy['format'] = "";
		if ($policy['var']['FORMAT'])
			$policy['format'] = $policy['var']['FORMAT'];

		$policy['format'] = trim($policy['format']);
 
		if (strlen($policy['format']) > 0) {
			$policy['format'] = base64_decode($policy['format']);

			if (!kwst_referee_eregi($policy['format'], $value))
				kwst_referee_error_handler("고급정책", $policy['format'], "POST", $key, $value, "지정되지 않은 형태의 변수값 입력");
		}

		/* 변수 데이터 길이 정책 적용 */
		$submit[$key]['length'] = strlen($value);

			// 최소길이 검사
		if (isset($policy['var']['MIN_LENGTH'])) {
			$policy['min_length'] = base64_decode($policy['var']['MIN_LENGTH']);

			if ($submit[$key]['length'] < $policy['min_length'])
				kwst_referee_error_handler("고급정책", ">=".$policy['min_length'], "POST", $key, $value, "최소 길이보다 작은 변수값 입력");
		}
			// 최대길이 검사
		if (isset($policy['var']['MAX_LENGTH'])) {
			$policy['max_length'] = base64_decode($policy['var']['MAX_LENGTH']);

			if ($submit[$key]['length'] > $policy['max_length'])
				kwst_referee_error_handler("고급정책", "<=".$policy['max_length'], "POST", $key, $value, "최대 길이보다 큰 변수값 입력");
		}

		/* 탐지 대상별 탐지 */

			// SQL_INJECTION 탐지
		$policy['sql_injection_bool'] = "FALSE";
		if (isset($policy['var']['TARGET']['SQL_INJECTION']))
			$policy['sql_injection_bool'] = base64_decode($policy['var']['TARGET']['SQL_INJECTION']);

		if ($policy['sql_injection_bool'] == "TRUE") {
			$pattern = kwst_referee_detect_sql_injection($value);
			if ($pattern)
				kwst_referee_error_handler("고급정책", $pattern, "POST", $key, $value, "SQL_Injection 공격 패턴 탐지");
		}

			// XSS 탐지
		$policy['xss'] = "FALSE";
		if (isset($policy['var']['TARGET']['XSS']))
			$policy['xss'] = base64_decode($policy['var']['TARGET']['XSS']);

		if ($policy['xss'] == "TRUE") {
			kwst_referee_detect_xss($value);
			if ($pattern)
				kwst_referee_error_handler("고급정책", $pattern, "POST", $key, $value, "XSS 공격 패턴 탐지");
		}

			// WORD 탐지
		$policy['word'] = "FALSE";
		if (isset($policy['var']['TARGET']['WORD']))
			$policy['word'] = base64_decode($policy['var']['TARGET']['WORD']);

		if ($policy['word'] == "TRUE") {
			$pattern = kwst_referee_detect_word($value);
			if ($pattern)
				kwst_referee_error_handler("고급정책", $pattern, "POST", $key, $value, "불량 WORD 탐지");
		}

			// TAG 탐지
		$policy['tag'] = "FALSE";
		if (isset($policy['var']['TARGET']['TAG']))
			$policy['tag'] = base64_decode($policy['var']['TARGET']['TAG']);

		if ($policy['tag'] == "TRUE") {
			$pattern = kwst_referee_detect_tag($value);
			if ($pattern)
				kwst_referee_error_handler("고급정책", $pattern, "POST", $key, $value, "TAG 공격 패턴 탐지");
		}

	}

	return;
}

/* KWST Referee 메인 함수 */
function kwst_referee_main()
{
		// IP 접근 시도 중재
	kwst_referee_check_site_policy();

		// IP 접근 시도 중재
	kwst_referee_check_ip_policy();

		// 고급 정책 적용(페이지별 정책)
	kwst_referee_check_advance_policy();

		// 기본 정책 적용
	kwst_referee_check_basic_policy();

		// COOKIE 중재
	kwst_referee_check_cookie_policy();

		// FILE 변수 중재
	kwst_referee_check_file_policy();

	return;
}
/* KWST 집행 프레임워크 함수들 끝 */


if (!isset($_KWST_POLICY['CONFIG']['MODE']['ENFORCING']))
	return;

/* KWST 템플릿 DISABLED 상태이면 바로 종료 */
$policy['disabled'] =& $_KWST_POLICY['CONFIG']['MODE']['DISABLED'];
$policy['disabled'] = base64_decode($policy['disabled']);

if ($policy['disabled'] == "TRUE")
	return;

/* KWST Referee 메인 함수 호출 */
kwst_referee_main();

/* End of kwst_referee.php */
?>
